%define anolis_release 1

%global _lto_cflags %{nil}
%define cuda_ver 11-8
%define cuda_main_version 11

Name: libnccl-cuda-%{cuda_main_version}
Version: 2.20.5
Release: %{anolis_release}%{?dist}
Summary: NVIDIA Collective Communication Library (NCCL) Runtime for cuda %{cuda_main_version}
License: BSD
URL: http://developer.nvidia.com/nccl
Source0: https://github.com/NVIDIA/nccl/archive/refs/tags/v%{version}-1.tar.gz#/nccl-%{version}-1.tar.gz
Patch1000: 1000-fix-lib-path-in-nccl.pc.patch
Patch1001: 1001-add-allow-unsupported-compiler-to-compat-gcc12.patch

BuildRequires: cuda-%{cuda_ver}
AutoReqProv: no
Requires: libgcc libstdc++
Conflicts: libnccl
ExclusiveArch: x86_64 aarch64

%description
NCCL (pronounced "Nickel") is a stand-alone library of standard collective
communication routines for GPUs, implementing all-reduce, all-gather, reduce,
broadcast, and reduce-scatter.
It has been optimized to achieve high bandwidth on any platform using PCIe,
NVLink, NVswitch, as well as networking using InfiniBand Verbs or TCP/IP
sockets.

%package -n libnccl-devel-cuda-%{cuda_main_version}
Summary: NCCL development files for cuda %{cuda_main_version}
Requires: libnccl-cuda-%{cuda_main_version} = %{version}-%{release}
Requires: /usr/bin/pkg-config
AutoReqProv: no
Conflicts: libnccl-devel

%description -n libnccl-devel-cuda-%{cuda_main_version}
NCCL development files for cuda %{cuda_main_version}

%package -n libnccl-static-cuda-%{cuda_main_version}
Summary: NCCL static library for cuda %{cuda_main_version}
Requires: libnccl-devel-cuda-%{cuda_main_version} = %{version}-%{release}
AutoReqProv: no
Conflicts: libnccl-static

%description -n libnccl-static-cuda-%{cuda_main_version}
NCCL static library for cuda %{cuda_main_version}

%prep
%autosetup -p1 -n nccl-%{version}-1

%build
export LD_LIBRARY_PATH=/usr/local/cuda-%{cuda_ver}/lib64
export CFLAGS=usr/local/cuda-%{cuda_ver}/include:$CFLAGS
export PREFIX=/usr
%make_build

%install
mkdir -p %{buildroot}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_libdir}/pkgconfig
cp -d build/lib/libnccl* %{buildroot}%{_libdir}
cp build/include/* %{buildroot}%{_includedir}
cp build/lib/pkgconfig/nccl.pc %{buildroot}%{_libdir}/pkgconfig/

%files
%license LICENSE.txt
%{_libdir}/libnccl.so.*

%files -n libnccl-devel-cuda-%{cuda_main_version}
%license LICENSE.txt
%{_includedir}/*.h
%{_libdir}/libnccl.so
%{_libdir}/pkgconfig/nccl.pc

%files -n libnccl-static-cuda-%{cuda_main_version}
%license LICENSE.txt
%{_libdir}/libnccl_static.a

%changelog
* Wed Jun 19 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.20.5-1
- update to 2.20.5

* Tue Mar 05 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.19.3-2
- set conflicts with libnccl for cuda12

* Mon Mar 04 2024 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.19.3-1
- 2.19.3 for cuda11.8
